<?php
if ( ! defined('ABSPATH') ) die();
// Admin bootstaps
require_once(ABSPATH.'wp-admin'.DIRECTORY_SEPARATOR.'admin.php');
require_once(ABSPATH.'wp-includes'.DIRECTORY_SEPARATOR.'pluggable.php');

// Do this here just to be on the safe side
if(!is_user_logged_in())
{
	header("Location:".get_bloginfo('home').'/wp-login.php');
	exit();
}
require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'functions.php');

$descendants_and_self = 0;
$selected_cats = false;
$popular_cats = false;
$post_id = 0;

$descendants_and_self = (int) $descendants_and_self;
$args = array();

if ( is_array( $selected_cats ) )
	$args['selected_cats'] = $selected_cats;
elseif ( $post_id )
	$args['selected_cats'] = wp_get_post_categories($post_ID);
else
	$args['selected_cats'] = array();

if ( is_array( $popular_cats ) )
	$args['popular_cats'] = $popular_cats;
else
	$args['popular_cats'] = get_terms( 'category', array( 'fields' => 'ids', 'orderby' => 'count', 'order' => 'DESC', 'number' => 10, 'hierarchical' => false ) );

if ( $descendants_and_self ) {
	$categories = get_categories( "child_of=$descendants_and_self&hierarchical=0&hide_empty=0" );
	$self = get_category( $descendants_and_self );
	array_unshift( $categories, $self );
} else {
	$categories = get_categories('get=all');
}

// Post process $categories rather than adding an exclude to the get_terms() query to keep the query the same across all posts (for any query cache)
$checked_categories = array();
$keys = array_keys( $categories );

foreach( $keys as $k ) {
	if ( in_array( $categories[$k]->term_id, $args['selected_cats'] ) ) {
		$checked_categories[] = $categories[$k];
		unset( $categories[$k] );
	}
}

// Get all tags
if(isset($_REQUEST['taxonomy']))
	$taxonomy = $_REQUEST['taxonomy'];
if ( empty($taxonomy) )
	$taxonomy = 'post_tag';
$searchterms = isset( $_GET['s'] ) ? trim( $_GET['s'] ) : '';

// Handle the creation of a post
if(isset($_POST) && !empty($_POST))
{
	if(isset($_FILES) && !empty($_FILES) && $_FILES['async-upload']['name'] != '')
	{
		$id = media_handle_upload('async-upload', $_REQUEST['post_id']);
		$file = get_attachment_icon_src($id, true);
		if($_POST['file_upload_location'] == 'top')
		{
			$_POST['content'] = '<img src="'.$file[0].'" />
'.$_POST['content'];
		} else if($_POST['file_upload_location'] == 'bottom')
		{
			$_POST['content'] .= '
<img src="'.$file[0].'" />';
		}
	}

	if(get_option('architect_admin_show_postedfrom'))
	{
		$text = get_option('architect_admin_postedfrom');
		if($info = architect_mobile_info())
		{
			$text = str_replace(
				array('{manufacturer}', '{model}'),
				array(ucwords($info['manufacturer']), ucwords(strtolower(str_replace('-', ' ', $info['model'])))),
				$text
			);
			
			$_POST['content'] .= '
	
'.$text;
		} else
		{
			$_POST['content'] .= '
'.str_replace(array('{manufacturer}', '{model}'), '', $text);
		}
	}

	// Setup correct categories array for saving
	$_POST['post_category'] = array();
	foreach(array_merge($checked_categories, $categories) as $cat)
	{
		if(isset($_POST['post_category_'.$cat->cat_ID]) AND $_POST['post_category_'.$cat->cat_ID] == true)
		{
			$_POST['post_category'][] = $cat->cat_ID;
		}
	}
	
	// Setup correct tags array for saving
	$_POST['tags_input'] = array();
	if(isset($_POST['tags_input_input']) AND $_POST['tags_input_input'] != '')
	{
		foreach(explode(',', $_POST['tags_input_input']) as $tag)
		{
			$_POST['tags_input'][] = trim($tag);
		}
	}
	
	if(isset($_POST['post_date_Y']) AND is_numeric($_POST['post_date_Y']) AND is_numeric($_POST['post_date_M']) AND is_numeric($_POST['post_date_D']) AND is_numeric($_POST['post_date_H']) AND is_numeric($_POST['post_date_Mi']))
	{
		$_POST['post_date'] = sprintf("%04s", $_POST['post_date_Y']).'-'.
			sprintf("%02s", $_POST['post_date_M']).'-'.
			sprintf("%02s", $_POST['post_date_D']).' '.
			sprintf("%02s", $_POST['post_date_H']).':'.
			sprintf("%02s", $_POST['post_date_Mi']).':00';
		$_POST['post_date_gmt'] = get_gmt_from_date($_POST['post_date']);
	}
	
	if($post_id  = write_post())
	{
		if(isset($_FILES) && !empty($_FILES) && $_FILES['async-upload']['name'] != '')
		{
			// Attach uploaded file to post
			global $wpdb;
			$attached = $wpdb->query($wpdb->prepare("UPDATE $wpdb->posts SET post_parent = %d WHERE post_type = 'attachment' AND ID = $id", $post_id));
		}
		header("Location:".admin_url().$_POST['_wp_http_referer'].'?message=1');
		exit();
	}
}
$waplString = '';
$pageTitle = 'Add New Post';
$pageId = 'addPost';
$thisMainMenu = 'Posts';

// Header
$waplString .= require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'header.php');

// Navigation
$waplString .= require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'menu'.DIRECTORY_SEPARATOR.'main.php');
$waplString .= require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'menu'.DIRECTORY_SEPARATOR.'edit.php');
$waplString .= '<wordsChunk id="'.$pageId.'"><quick_text>[p]add new post[/p][h2]'.$pageH1.'[/h2]</quick_text></wordsChunk>';

global $user_ID;
$form_action = 'post';
$post_ID = isset($post_ID) ? (int) $post_ID : 0;
$post = get_default_post_to_edit();
$temp_ID = -1 * time();

// Form to write a post
$waplString .= '
<form>
	<action>post-new.php</action>
	<formItem item_type="hidden"><name>action</name><value>post-quickpress-save</value></formItem>
	<formItem item_type="hidden"><name>comment_status</name><value>open</value></formItem>
	<formItem item_type="hidden"><name>ping_status</name><value>open</value></formItem>
	<formItem item_type="hidden"><name>quickpress_post_ID</name><value>0</value></formItem>
	<formItem item_type="hidden"><name>_wpnonce</name><value>'.wp_create_nonce('add-post').'</value></formItem>
	<formItem item_type="hidden"><name>_wp_http_referer</name><value>edit.php</value></formItem>
	<formItem item_type="hidden"><name>post_type</name><value>post</value></formItem>
	<formItem item_type="hidden"><name>user_ID</name><value>'.(int) $user_ID.'</value></formItem>
	<formItem item_type="hidden"><name>post_id</name><value>0</value></formItem>
	<formItem item_type="hidden"><name>temp_ID</name><value>'.$temp_ID.'</value></formItem>
	<formItem item_type="text"><label>Title</label><name>post_title</name><value></value></formItem>
	<formItem item_type="textarea"><label>Content</label><name>content</name><value></value></formItem>
	<formItem item_type="textarea"><label>Excerpt</label><name>excerpt</name><value></value></formItem>';

$current_user = wp_get_current_user();
$user_id = $current_user->ID;
$can_upload = get_option('architect_admin_file_upload_'.$user_id);

if($can_upload === '0')
{
	$waplString .= '<formItem item_type="title"><name>async-upload-off</name><label>File uploading is disabled for this user. To re-enable it, switch it back on in the [url=profile.php]Profile[/url] page</label></formItem>';
} else
{
	$waplString .= '<formItem item_type="file"><label>File Upload</label><name>async-upload</name></formItem>
	<formItem item_type="select">
		<label>Image Location</label><name>file_upload_location</name>
		<possibility>
			<label>Top</label>
			<value>top</value>
		</possibility>
		<possibility>
			<label>Bottom</label>
			<value>bottom</value>
		</possibility>
	</formItem>';
}

// Post status
$waplString .= '
	<formItem item_type="select"><name>post_status</name>
	<label>Post Status</label>
		<possibility>
			<label>Draft</label>
			<value>draft</value>
		</possibility>
		<possibility>
			<label>Pending Review</label>
			<value>pending</value>
		</possibility>';
if(current_user_can('publish_posts'))
{
	$waplString .= '<possibility>
			<label>Published</label>
			<value>publish</value>
		</possibility>
		<possibility>
			<label>Future</label>
			<value>future</value>
		</possibility>';
}
 
$waplString .= '
	</formItem>';

// Publish date
$waplString .= '</form></layout><layout start_stack="div"><form><formItem item_type="title"><name></name><label>Publish Date</label></formItem>';
$waplString .= '<formItem item_type="select" class="post_date"><name>post_date_M</name>
	<label></label>
	<value>'.date("m").'</value>
	<possibility><label>Jan</label><value>01</value></possibility>
	<possibility><label>Feb</label><value>02</value></possibility>
	<possibility><label>Mar</label><value>03</value></possibility>
	<possibility><label>Apr</label><value>04</value></possibility>
	<possibility><label>May</label><value>05</value></possibility>
	<possibility><label>Jun</label><value>06</value></possibility>
	<possibility><label>Jul</label><value>07</value></possibility>
	<possibility><label>Aug</label><value>08</value></possibility>
	<possibility><label>Sep</label><value>09</value></possibility>
	<possibility><label>Oct</label><value>10</value></possibility>
	<possibility><label>Nov</label><value>11</value></possibility>
	<possibility><label>Dec</label><value>12</value></possibility>
	
</formItem>';

if ( !wp_timezone_supported() )
{
	$waplString .= '<formItem item_type="text" class="post_date"><label></label><name>post_date_D</name><maxlength>2</maxlength><value>'.date("d").'</value><input_mask>*N</input_mask></formItem>';
	$waplString .= '<formItem item_type="text" class="post_date"><label>,</label><name>post_date_Y</name><maxlength>4</maxlength><value>'.date("Y").'</value><input_mask>*N</input_mask></formItem>';
	$waplString .= '<formItem item_type="text" class="post_date"><label>@</label><name>post_date_H</name><maxlength>2</maxlength><value>'.date("H").'</value><input_mask>*N</input_mask></formItem>';
	$waplString .= '<formItem item_type="text" class="post_date"><label>:</label><name>post_date_Mi</name><maxlength>2</maxlength><value>'.date("i").'</value><input_mask>*N</input_mask></formItem>';
} else
{
	$timezone_format = _x('Y-m-d G:i:s', 'timezone date format');
	$date = date_i18n($timezone_format);
	
	$waplString .= '<formItem item_type="text" class="post_date"><label></label><name>post_date_D</name><maxlength>2</maxlength><value>'.date("d", strtotime($date)).'</value><input_mask>*N</input_mask></formItem>';
	$waplString .= '<formItem item_type="text" class="post_date"><label>,</label><name>post_date_Y</name><maxlength>4</maxlength><value>'.date("Y", strtotime($date)).'</value><input_mask>*N</input_mask></formItem>';
	$waplString .= '<formItem item_type="text" class="post_date"><label>@</label><name>post_date_H</name><maxlength>2</maxlength><value>'.date("H", strtotime($date)).'</value><input_mask>*N</input_mask></formItem>';
	$waplString .= '<formItem item_type="text" class="post_date"><label>:</label><name>post_date_Mi</name><maxlength>2</maxlength><value>'.date("i", strtotime($date)).'</value><input_mask>*N</input_mask></formItem>';
}

$waplString .= '</form></layout><layout start_stack="table"><form>';

// Assign categories
$waplString .= '<formItem class="dashboardSection" item_type="title"><label>Categories</label><name>categories</name></formItem>';

foreach($checked_categories as $val)
{
	$waplString .= '<formItem class="postCheckbox" item_type="checkbox"><label>'.$val->name.'</label><name>post_category_'.$val->cat_ID.'</name><value>'.$val->cat_ID.'</value></formItem>';
}
foreach($categories as $val)
{
	$waplString .= '<formItem class="postCheckbox" item_type="checkbox"><label>'.$val->name.'</label><name>post_category_'.$val->cat_ID.'</name><value>'.$val->cat_ID.'</value></formItem>';
}	

// Assign tags
$waplString .= '<formItem class="dashboardSection" item_type="title"><label>Tags</label><name>tags</name></formItem>';
$waplString .= '<formItem item_type="text"><name>tags_input_input</name><label>Add new tags</label></formItem>';
$waplString .= '<formItem class="formItemComment" item_type="title"><label>Separate tags with commas</label></formItem>';

$waplString .= '
	<formItem item_type="submit"><label>Add</label><name>add_new_save</name></formItem>
</form>';

// Footer
$waplString .= require_once(ARCHITECT_ADMIN_DIR.'wp-admin'.DIRECTORY_SEPARATOR.'footer.php');

// Convert WAPL into markup
process_admin_wapl($waplString);
?>